#include "PDFOutline.h"

PDFOutline::PDFOutline(PDF *Parent):
    mParent(Parent)
{
    fz_error *error;
    error = pdf_loadoutline(&mOutlineRoot, mParent->mSrc);
    if (error)
        mOutlineRoot= NULL;

    location = mOutlineRoot;
}

PDFOutline::~PDFOutline()
{
    if(mOutlineRoot)
    {
        pdf_dropoutline(mOutlineRoot);
    }
    mOutlineRoot = NULL;
}

bool PDFOutline::loadfailure()
{
    return mOutlineRoot == NULL;
}

bool PDFOutline::HasNextSibling()
{
    return location->next != NULL;
}

bool PDFOutline::HasChild()
{
    return location->child != NULL;
}

char *PDFOutline::GetCurrentNodeText()
{
    if(location)
        return location->title;
    return NULL;
}

int PDFOutline::GetCurrentNodeLinkPageNumber()
{
    return mParent->GetLinkPageNumber(location->link);
}

void PDFOutline::GotoNextSibling()
{
    if(HasNextSibling())
        location = location->next;
}

void PDFOutline::GotoChild()
{
    if(HasChild())
        location = location->child;
}

void PDFOutline::GotoRoot()
{
    location = mOutlineRoot;
}
